%define anolis_release 3

# Disable debuginfo packages
%global debug_package %{nil}
%global _binaries_in_noarch_packages_terminate_build 0

# Do not check any files in doc or src for requires
%global __requires_exclude_from ^(%{_datadir}|/usr/lib)/%{name}/(doc|src)/.*$

# Don't alter timestamps of especially the .a files (or else go will rebuild later)
# Actually, don't strip at all since we are not even building debug packages and this corrupts the dwarf testdata
%global __strip /bin/true

# Set goroot golibdir path
%global golibdir  %{_libdir}/golang
%global goroot    /usr/lib/%{name}

# This macro may not always be defined, ensure it is
%{!?gopath: %global gopath %{_datadir}/gocode}

# rpmbuild magic to keep from having meta dependency on libc.so.6
%define _use_internal_dependency_generator 0
%define __find_requires %{nil}
%global __spec_install_post /usr/lib/rpm/check-rpaths   /usr/lib/rpm/check-buildroot  \
  /usr/lib/rpm/brp-compress

#### Golang build options.
# Build golang with cgo enabled/disabled(later equals more or less to internal linking).
%bcond_without cgo

# Build golang using external/internal(close to cgo disabled) linking.
%bcond_without external_linker

# Use golang/gcc-go as bootstrap compiler
%bcond_with bootstrap

# Controls what ever we fail on failed tests
%ifarch aarch64 loongarch64
%bcond_with fail_on_tests
%else
%bcond_without fail_on_tests
%endif

# Build golang shared objects for stdlib
%ifarch loongarch64 riscv64
%bcond_with shared
%else
%bcond_without shared
%endif

# Pre build std lib with -race enabled
# Disabled due to 1.20 new cache usage, see 1.20 upstream release notes
%bcond_with race


%ifarch x86_64
%global gohostarch  amd64
%endif
%ifarch aarch64
%global gohostarch  arm64
%endif
%ifarch loongarch64
%global gohostarch  loong64
%endif
%ifarch riscv64
%global gohostarch  riscv64
%endif

# Comment out go_patch as needed
%global go_api 1.24
%global go_patch 0

Name:           golang
Version:        %{go_api}%{?go_patch:.%{go_patch}}
Release:        %{anolis_release}%{?dist}
Summary:        The Go Programming Language
License:        BSD and Public Domain
URL:            https://go.dev
Source0:        https://go.dev/dl/go%{go_api}%{?go_patch:.%{go_patch}}.src.tar.gz
# make possible to override default traceback level at build time by setting build tag rpm_crashtraceback
Source1:        anolis.go

Patch1:         0001-cmd-link-internal-add-support-for-internal-linking-o.patch
Patch2:         0002-cmd-dist-internal-platform-enable-internal-linking-f.patch
Patch3:         0003-cmd-runtime-enable-race-detector-on-loong64.patch
Patch4:         0004-runtime-delete-on-register-ABI-fallback-path-for-rac.patch
Patch5:         0005-cmd-internal-obj-loong64-remove-unused-register-alia.patch
Patch6:         0006-internal-bytealg-optimize-IndexByte-and-IndexByteStr.patch
Patch7:         0007-internal-bytealg-optimize-memequal-and-memequal_varl.patch
Patch8:         0008-internal-bytealg-optimize-Index-and-IndexString-func.patch
Patch9:         0009-internal-bytealg-optimize-Count-and-CountString-func.patch
Patch10:         0010-internal-bytealg-adjust-the-format-of-assembly-files.patch
Patch11:         0011-cmd-internal-obj-loong64-optimize-immediate-loading.patch
Patch12:         0012-math-big-optimize-addVV-function-for-loong64.patch
Patch13:         0013-math-big-optimize-addVW-function-for-loong64.patch
Patch14:         0014-math-big-optimize-subVV-function-for-loong64.patch
Patch15:         0015-math-big-optimize-subVW-function-for-loong64.patch
Patch16:         0016-math-big-optimize-shlVU-function-for-loong64.patch
Patch17:         0017-math-big-optimize-shrVU-function-for-loong64.patch
Patch18:         0018-math-big-optimize-mulAddVWW-function-for-loong64.patch
Patch19:         0019-math-big-optimize-addMulVVW-function-for-loong64.patch
Patch20:         0020-cmd-compile-fold-constant-shift-with-extension-on-lo.patch
Patch21:         0021-test-codegen-fix-the-matching-instructions-inside-pl.patch
Patch22:         0022-cmd-compile-optimize-shifts-of-int32-and-uint32-on-l.patch
Patch23:         0023-cmd-compile-simplify-bounded-shift-on-loong64.patch
Patch24:         0024-runtime-use-ABIInternal-on-syscall-and-other-sys.stu.patch
Patch25:         0025-runtime-use-correct-memory-barrier-in-exitThread-fun.patch
Patch26:         0026-cmd-internal-obj-loong64-add-V-XV-SEQI-V-XV-.-AND-OR.patch
Patch27:         0027-cmd-internal-obj-loong64-add-V-XV-ADD-SUB-.-B-H-W-D-.patch
Patch28:         0028-cmd-internal-obj-loong64-add-V-XV-ILV-L-H-.-B-H-W-D-.patch
Patch29:         0029-cmd-internal-obj-loong64-add-V-XV-SLL-SRL-SRA-ROTR-I.patch
Patch30:         0030-cmd-internal-obj-loong64-add-V-XV-FSQRT-FRECIP-FRSQR.patch
Patch31:         0031-cmd-internal-obj-loong64-add-V-XV-NEG-B-H-W-V-instru.patch
Patch32:         0032-cmd-internal-obj-loong64-add-V-XV-MUL-B-H-W-V-and-V-.patch
Patch33:         0033-cmd-internal-obj-loong64-add-V-XV-DIV-B-H-W-V-U-and-.patch
Patch34:         0034-cmd-internal-obj-loong64-add-V-XV-BITCLR-BITSET-BITR.patch
Patch35:         0035-crypto-chacha20-add-loong64-SIMD-implementation.patch
Patch36:         0036-internal-bytealg-optimize-Count-String-in-loong64.patch
Patch37:         0037-cmd-internal-obj-cmd-asm-reclassify-32-bit-immediate.patch
Patch38:         0038-crypto-internal-poly1305-implement-function-update-i.patch
Patch39:         0039-runtime-optimize-the-implementation-of-memclrNoHeapP.patch
Patch40:         0040-runtime-race-add-the-implementation-of-atomic.-Or-An.patch
Patch41:         0041-cmd-internal-obj-loong64-add-F-MAXA-MINA-.-S-D-instr.patch
Patch42:         0042-math-implement-func-archExp-and-archExp2-in-assembly.patch
Patch43:         0043-math-implement-func-archLog-in-assembly-on-loong64.patch
Patch44:         0044-cmd-go-internal-work-allow-a-bunch-of-loong64-specif.patch

# The compiler is written in Go. Needs go(1.4+) compiler for build.
%if %{with bootstrap}
BuildRequires:  gcc-go >= 5
%else
BuildRequires:  golang > 1.4
%endif
BuildRequires:  hostname
# for tests
BuildRequires:  pcre-devel
BuildRequires:  glibc-static
BuildRequires:  perl-interpreter
BuildRequires:  procps-ng

Provides:       go = %{version}-%{release}

# Bundled/Vendored provides can be found in `find . -name modules.txt` on the in tree module data
# - in version filed substituted with . per versioning guidelines
Provides: bundled(golang(github.com/google/pprof)) = 0.0.0.20221118152302.e6195bd50e26
Provides: bundled(golang(github.com/ianlancetaylor/demangle)) = 0.0.0.20220319035150.800ac71e25c2
Provides: bundled(golang(golang.org/x/arch)) = 0.1.1.0.20221116201807.1bb480fc256a
Provides: bundled(golang(golang.org/x/crypto)) = 0.3.1.0.20221117191849.2c476679df9a
Provides: bundled(golang(golang.org/x/mod)) = 0.7.0
Provides: bundled(golang(golang.org/x/net)) = 0.4.1.0.20230214201333.88ed8ca3307d
Provides: bundled(golang(golang.org/x/sync)) = 0.1.0
Provides: bundled(golang(golang.org/x/sys)) = 0.3.0
Provides: bundled(golang(golang.org/x/term)) = 0.2.0
Provides: bundled(golang(golang.org/x/text)) = 0.5.0
Provides: bundled(golang(golang.org/x/tools)) = 0.3.1.0.20230118190848.070db2996ebe

Requires:       %{name}-bin = %{version}-%{release}
Requires:       %{name}-src = %{version}-%{release}

Source100:      golang-gdbinit

## git binary diffs are not supported. (Patch1051)
Source102:	race_linux_loong64.syso

%description
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

%package        docs
Summary:        Golang compiler docs
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    docs
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes compiler documents of Go.

%package        misc
Summary:        Golang compiler miscellaneous sources
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    misc
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes misc of Go.

%package        tests
Summary:        Golang compiler tests for stdlib
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    tests
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes compiler tests for stdlib of Go.

%package         src
Summary:         Golang compiler source tree
BuildArch:       noarch
%description     src
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes compiler source tree of Go.

%package         bin
Summary:         Golang core compiler tools
# Some distributions refer to this package by this name
Provides:        %{name}-go = %{version}-%{release}
Requires:        go = %{version}-%{release}
Requires(post):  %{_sbindir}/update-alternatives
Requires(preun): %{_sbindir}/update-alternatives

# We strip the meta dependency, but go does require glibc.
# This is an odd issue, still looking for a better fix.
Requires:        glibc
Requires:        gcc
Recommends:      git, subversion, mercurial

%description     bin
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes core compiler tools of Go.

# Workaround old RPM bug of symlink-replaced-with-dir failure
%pretrans -p <lua>
for _,d in pairs({"api", "doc", "include", "lib", "src"}) do
  path = "%{goroot}/" .. d
  if posix.stat(path, "type") == "link" then
    os.remove(path)
    posix.mkdir(path)
  end
end

%if %{with shared}
%package         shared
Summary:         Golang shared object libraries

%description     shared
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes shared object libraries of Go.
%endif

%if %{with race}
%package         race
Summary:         Golang std library with -race enabled

Requires:        %{name} = %{version}-%{release}

%description     race
The Go programming language is an open source project to make programmers more productive.

Go is expressive, concise, clean, and efficient. Its concurrency mechanisms
make it easy to write programs that get the most out of multicore and networked
machines, while its novel type system enables flexible and modular program
construction.

Go compiles quickly to machine code yet has the convenience of garbage
collection and the power of run-time reflection. It's a fast, statically typed,
compiled language that feels like a dynamically typed, interpreted language.

This package includes std library with -race enabled of Go.
%endif

%prep
%autosetup -p1 -n go

cp %{SOURCE1}   ./src/runtime/
cp %{SOURCE102} ./src/runtime/race

%build
# print out system information
uname -a
cat /proc/cpuinfo
cat /proc/meminfo

# bootstrap compiler GOROOT
%if %{with bootstrap}
export GOROOT_BOOTSTRAP=/
%else
export GOROOT_BOOTSTRAP=%{goroot}
%endif

# set up final install location
export GOROOT_FINAL=%{goroot}

export GOHOSTOS=linux
export GOHOSTARCH=%{gohostarch}

pushd src
# use our gcc options for this build, but store gcc as default for compiler
export CFLAGS="$RPM_OPT_FLAGS"
export LDFLAGS="$RPM_LD_FLAGS"
export CC="gcc"
export CC_FOR_TARGET="gcc"
export GOOS=linux
export GOARCH=%{gohostarch}
%if !%{with external_linker}
export GO_LDFLAGS="-linkmode internal"
%endif
%if !%{with cgo}
export CGO_ENABLED=0
%endif
./make.bash --no-clean -v
popd

# build shared std lib
%if %{with shared}
GOROOT=$(pwd) PATH=$(pwd)/bin:$PATH go install -buildmode=shared -v -x std
%endif

%if %{with race}
GOROOT=$(pwd) PATH=$(pwd)/bin:$PATH go install -race -v -x std
%endif

%install
echo "== 1 =="
rm -rf %{buildroot}
# remove GC build cache
rm -rf pkg/obj/go-build/*

# create the top level directories
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{goroot}

# install everything into libdir (until symlink problems are fixed)
# https://code.google.com/p/go/issues/detail?id=5830
cp -apv api bin doc lib pkg src misc test VERSION \
   %{buildroot}%{goroot}
echo "== 2 =="
# bz1099206
find %{buildroot}%{goroot}/src -exec touch -r %{buildroot}%{goroot}/VERSION "{}" \;
# and level out all the built archives
touch %{buildroot}%{goroot}/pkg
find %{buildroot}%{goroot}/pkg -exec touch -r %{buildroot}%{goroot}/pkg "{}" \;
# generate the spec file ownership of this source tree and packages
cwd=$(pwd)
src_list=$cwd/go-src.list
pkg_list=$cwd/go-pkg.list
shared_list=$cwd/go-shared.list
race_list=$cwd/go-race.list
misc_list=$cwd/go-misc.list
docs_list=$cwd/go-docs.list
tests_list=$cwd/go-tests.list
rm -f $src_list $pkg_list $docs_list $misc_list $tests_list $shared_list $race_list
touch $src_list $pkg_list $docs_list $misc_list $tests_list $shared_list $race_list
pushd %{buildroot}%{goroot}
  echo "== 3 =="
    find src/ -type d -a \( ! -name testdata -a ! -ipath '*/testdata/*' \) \
        -printf '%%%dir %{goroot}/%p\n' >> $src_list
    find src/ ! -type d -a \( ! -ipath '*/testdata/*' -a ! -name '*_test.go' \) \
        -printf '%{goroot}/%p\n' >> $src_list

    find bin/ pkg/ -type d -a ! -path '*_dynlink/*' -a ! -path '*_race/*' \
        -printf '%%%dir %{goroot}/%p\n' >> $pkg_list
    find bin/ pkg/ ! -type d -a ! -path '*_dynlink/*' -a ! -path '*_race/*' \
        -printf '%{goroot}/%p\n' >> $pkg_list

    find doc/ -type d \
        -printf '%%%dir %{goroot}/%p\n' >> $docs_list
    find doc/ ! -type d \
        -printf '%{goroot}/%p\n' >> $docs_list

    find misc/ -type d \
        -printf '%%%dir %{goroot}/%p\n' >> $misc_list
    find misc/ ! -type d \
        -printf '%{goroot}/%p\n' >> $misc_list

%if %{with shared}
echo "== 4 =="
    mkdir -p %{buildroot}/%{_libdir}/
    mkdir -p %{buildroot}/%{golibdir}/
    for file in $(find .  -iname "*.so" ); do
        chmod 755 $file
        mv  $file %{buildroot}/%{golibdir}
        pushd $(dirname $file)
        ln -fs %{golibdir}/$(basename $file) $(basename $file)
        popd
        echo "%%{goroot}/$file" >> $shared_list
        echo "%%{golibdir}/$(basename $file)" >> $shared_list
    done
    
    find pkg/*_dynlink/ -type d \
        -printf '%%%dir %{goroot}/%p\n' >> $shared_list
    find pkg/*_dynlink/ ! -type d \
        -printf '%{goroot}/%p\n' >> $shared_list
%endif

echo "== 5 =="

%if %{with race}
    find pkg/*_race/ -type d \
        -printf '%%%dir %{goroot}/%p\n' >> $race_list
    find pkg/*_race/ ! -type d \
        -printf '%{goroot}/%p\n' >> $race_list
%endif

    find test/ -type d \
        -printf '%%%dir %{goroot}/%p\n' >> $tests_list
    find test/ ! -type d \
        -printf '%{goroot}/%p\n' >> $tests_list
    find src/ -type d -a \( -name testdata -o -ipath '*/testdata/*' \) \
        -printf '%%%dir %{goroot}/%p\n' >> $tests_list
    find src/ ! -type d -a \( -ipath '*/testdata/*' -o -name '*_test.go' \) \
        -printf '%{goroot}/%p\n' >> $tests_list
    # this is only the zoneinfo.zip
    find lib/ -type d \
        -printf '%%%dir %{goroot}/%p\n' >> $tests_list
    find lib/ ! -type d \
        -printf '%{goroot}/%p\n' >> $tests_list
popd
echo "== 6 =="
# remove the doc Makefile
rm -rfv %{buildroot}%{goroot}/doc/Makefile

# put binaries to bindir, linked to the arch we're building,
# leave the arch independent pieces in {goroot}
mkdir -p %{buildroot}%{goroot}/bin/linux_%{gohostarch}
ln -sf %{goroot}/bin/go %{buildroot}%{goroot}/bin/linux_%{gohostarch}/go
ln -sf %{goroot}/bin/gofmt %{buildroot}%{goroot}/bin/linux_%{gohostarch}/gofmt

# ensure these exist and are owned
mkdir -p %{buildroot}%{gopath}/src/github.com \
    %{buildroot}%{gopath}/src/bitbucket.org \
    %{buildroot}%{gopath}/src/code.google.com/p \
    %{buildroot}%{gopath}/src/golang.org/x
echo "== 7 =="
# make sure these files exist and point to alternatives
rm -f %{buildroot}%{_bindir}/go
ln -sf /etc/alternatives/go %{buildroot}%{_bindir}/go
rm -f %{buildroot}%{_bindir}/gofmt
ln -sf /etc/alternatives/gofmt %{buildroot}%{_bindir}/gofmt

# gdbinit
mkdir -p %{buildroot}%{_sysconfdir}/gdbinit.d
cp -av %{SOURCE100} %{buildroot}%{_sysconfdir}/gdbinit.d/golang.gdb

echo "== END OF INSTALL =="

%check
export GOROOT=$(pwd -P)
export PATH="$GOROOT"/bin:"$PATH"
cd src

export CC="gcc"
export CFLAGS="$RPM_OPT_FLAGS"
export LDFLAGS="$RPM_LD_FLAGS"
%if !%{with external_linker}
export GO_LDFLAGS="-linkmode internal"
## %else
## export GO_LDFLAGS="-extldflags '$RPM_LD_FLAGS'"
%endif
%if !%{with cgo} || !%{with external_linker}
export CGO_ENABLED=0
%endif
# workaround for https://github.com/golang/go/issues/39466 until it gests fixed
# Commented until the patch is ready, this workaround suggested in the link above
# doesn't work properly
#ifarch aarch64
#export CGO_CFLAGS="-mno-outline-atomics"
#endif

# make sure to not timeout
export GO_TEST_TIMEOUT_SCALE=2

%if %{with fail_on_tests}
./run.bash --no-rebuild -v -v -v -k
%else
./run.bash --no-rebuild -v -v -v -k || :
%endif
cd ..

%post bin
%{_sbindir}/update-alternatives \
    --install %{_bindir}/go \
    go %{goroot}/bin/go 90 \
    --slave %{_bindir}/gofmt \
    gofmt %{goroot}/bin/gofmt

%preun bin
if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives \
        --remove go %{goroot}/bin/go
fi

%files
%license LICENSE PATENTS
# VERSION has to be present in the GOROOT, for `go install std` to work
%doc %{goroot}/VERSION
%dir %{goroot}/doc

# go files
%dir %{goroot}
%{goroot}/api/
%{goroot}/lib/time/

# gdbinit (for gdb debugging)
%{_sysconfdir}/gdbinit.d

# ensure directory ownership, so they are cleaned up if empty
%dir %{gopath}
%dir %{gopath}/src
%dir %{gopath}/src/bitbucket.org/
%dir %{gopath}/src/code.google.com/
%dir %{gopath}/src/code.google.com/p/
%dir %{gopath}/src/github.com/
%dir %{gopath}/src/golang.org
%dir %{gopath}/src/golang.org/x

%files bin -f go-pkg.list
%{_bindir}/go
%{_bindir}/gofmt
%{goroot}/bin/linux_%{gohostarch}/go
%{goroot}/bin/linux_%{gohostarch}/gofmt

%files src -f go-src.list

%files misc -f go-misc.list

%files tests -f go-tests.list

%if %{with shared}
%files shared -f go-shared.list
%endif

%if %{with race}
%files race -f go-race.list
%endif

%files docs -f go-docs.list

%changelog
* Fri Apr 35 2025 Shangtong Guo <guo.shangtong@zte.com.cn> - 1.24.0-3
- add support for riscv64 build

* Mon Feb 24 2025 limeidan <limeidan@loongson.cn> - 1.24.0-2
- add internal linker support on loong64
- optimize the internal/bytealg package on loong64
- optimize the math/big package on loong64
- add new instructions support on loong64
- optimize memory operation function of runtime on loong64

* Tue Feb 18 2025 gaochang <gc-taifu@linux.alibaba.com> - 1.24.0-1
- update to 1.24.0

* Tue Feb 18 2025 gaochang <gc-taifu@linux.alibaba.com> - 1.22.12-1
- update to 1.22.12

* Wed Jul 10 2024 yangxinyu <yangxinyu@nfschina.com> - 1.21.11-1
- update to 1.21.11 fix cve-2024-24789

* Thu Jun 13 2024 chenguoqi <chenguoqi@loongson.cn> - 1.21.10-2
- add buildmode={plugin,shared} support on linux/loong64
- asan and msan support on linux/loong64
- loong64 disassembler support
- add atomic memory access instructions support
- optimize atomic xchg and xchg64 on loong64
- optimize atomic xadd and xadd64 on loong64
- optimize atomic And{32,8} and Or{32,8} on loong64
- asm: recheck jump offset boundary after auto-aligning loop heads
- cmd/link/internal/loadelf: correct the relocation size of R_LARCH_64
- enable regabi support on loong64
- add race support on loong64

* Thu May 09 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.21.10-1
- update to 1.21.10

* Mon Dec 11 2023 Funda Wang <fundawang@yeah.net> - 1.20.12-1
- New version 1.20.12

* Sat Oct 28 2023 Funda Wang <fundawang@yeah.net> - 1.20.10-1
- New version 1.20.10

* Fri Oct 27 2023 Meidan Li <limeidan@loongson.cn> - 1.20.9-3
- api: add new relocations numbered 101 to 109 for loong64
- cmd/link: add new relocations numbered 101 to 109 for loong64
- cmd/link/internal/loadelf: add additional relocations for loong64
- cmd/link/internal/loadelf: remove useless relocation size information of loong64
- cmd/internal, cmd/link: unify the relocation naming style of loong64
- cmd/internal/obj/loong64: using LookupABI to find duff{copy,zero} when rewriting GOT
- all: delete loong64 non-register ABI fallback path
- internal/abi, internal/buildcfg: always enable register ABI on loong64
- cmd/compile, internal/buildcfg: enable regABI on loong64, and add loong64 in test func hasRegisterABI
- runtime/internal/syscall: use ABIInternal for Syscall6 on loong64
- cmd/compile: fix If lowering on loong64
- cmd/internal/obj: set morestack arg spilling and regabi prologue on loong64
- runtime: add regABI support in memclr and memmove functions on loong64
- internal/bytealg: add regABI support in bytealg functions on loong64
- reflect, runtime: add reflect support for regABI on loong64
- runtime: support regABI and add spill functions in runtime for loong64
- runtime: make duff device as ABIInternal for loong64
- cmd/compile: update loong64 CALL* ops
- cmd/compile/internal: add spill support for loong64 regABI
- cmd/compile/internal: add register info for loong64 regABI
- internal/abi: define loong64 regABI constants
- cmd/compile,cmd/internal,runtime: change registers on loong64 to avoid regABI arguments
- cmd/compile: add ABI register definations for loong64
- cmd/compile, cmd/internal, runtime: change the registers used by the duff device for loong64
- cmd/link/internal/loadelf: correct the relocation size of R_LARCH_64
- cmd/link/internal/loong64: correct the glibc dynamic linker path.
- cmd/internal/obj/loong64: recheck jump offset boundary after auto-aligning loop heads
- cmd/internal/obj/loong64: correct the instruction format of plan9 assembly NOOP
- cmd/compiler,runtime/internal/atomic: Implementing {And,Or}{32,8} using am{and,or}dbw on loong64
- cmd/compiler,runtime/internal/atomic: Implementing xadd{,64} using amadddb{w,d} on loong64
- cmd/compiler,runtime/internal/atomic: Implementing xchg{,64} using amswapdb{w,d} on loong64
- internal/sysinfo: print cpu type from cpuinfo when internal cpu name is empty on Linux

* Wed Oct 18 2023 Meidan Li <limeidan@loongson.cn> - 1.20.9-2
- cmd/asm: add RDTIME{L,H}.W, RDTIME.D support for loong64
- runtime: implement cputicks with the stable counter on loong64
- runtime: remove the fake mstart caller in systemstack on linux/loong64
- cmd/internal/obj/loong64: save LR after decrementing SP
- runtime: refactor the linux/loong64 entrypoint
- cmd/internal/obj/loong64: remove invalid branch delay slots
- runtime: calculate nanoseconds in usleep on linux/loong64
- cmd/internal/obj: remove redundant cnames on loong64
- runtime: save/fetch g register during VDSO on loong64
- runtime: save/restore callee-saved registers in loong64's sigtramp
- runtime: add comment for sys_linux_loong64
- runtime: mark morestack_noctxt SPWRITE for linux/loong64
- cmd/internal/obj/loong64: add the PCALAU12I instruction for reloc use
- cmd/internal/obj/loong64, cmd/link/internal/loong64: switch to LoongArch ELF psABI v2 relocs
- runtime: add support for --buildmode=c-shared on loong64
- cmd/compile: add support for --buildmode=c-shared on loong64
- cmd/internal/obj/loong64, cmd/internal/objabi: add c-shared relocations on loong64
- cmd/link: add support for --buildmode=c-shared on loong64
- cmd/internal/sys: enable c-shared feature on loong64
- cmd/dist, misc/cgo/testcshared: enable c-shared test on loong64
- cmd/link, cmd/internal: in shared mode, change to use IE mode to access TLS variables
- cmd/compile, cmd/dist, cmd/go, internal: enable buildmode=pie for linux/loong64
- net: disable TestLookupDotsWithRemoteSource and TestLookupGoogleSRV
- enable c-archive test on linux/loong64
- cmd/internal, cmd/link: remove invalid GOT relative relocations
- runtime: no need to save these registers in load_g&save_g
- cmd/internal/obj/loong64: add support for movgr2cf and movcf2gr instructions
- runtime: save and restore fcc registers in async preempt on loong64
- cmd,cmd/vendor: pick up updates for golang.org/x/arch/loong64
- cmd/internal/objfile: add loong64 disassembler support
- cmd/{compile,link,internal},runtime: support -buildmode=shared for loong64
- cmd/{link,internal}: support -buildmode=plugin for loong64
- cmd/dist/test: enable buildmode={shared,plugin} test for loong64
- runtime: enable memory sanitizer on loong64
- runtime: enable address sanitizer on loong64
- cmd/link: workaround linkshared test errors on loong64.
- runtime: remove the meaningless offset of 8 for duffzero on loong64
- cmd/compiler: remove the meaningless offset of 8 for Lowered{Zero,Move} on loong64
- cmd/compile/internal, runtime: use NOOP for hardware NOPs on loong64
- cmd/link/internal/loong64: use BREAK 0 as the code pad sequence
- cmd/asm, runtime: remove the RSB register from loong64
- cmd/internal/obj/loong64: realize all unconditional jumps with B/BL
- cmd/internal/obj/loong64: clean up code for short conditional branches
- cmd/internal/obj/loong64: assemble BEQ/BNEs comparing with 0 as beqz/bnez
- cmd/internal/obj/loong64: remove Optab.family and reorganize operand class fields
- cmd/asm: support the PCALIGN directive on loong64
- internal/bytealg, runtime: align some loong64 asm loops to 16-byte boundaries
- cmd/link: bump loong64 function alignment to 16 bytes
- cmd/compile: optimize multiplication on loong64
- cmd/compile: split DIVV/DIVVU op on loong64
- cmd/internal/obj/loong64: auto-align loop heads to 16-byte boundaries
- cmd/internal/obj/loong64: add atomic memory access instructions support
- cmd/compiler,runtime/internal/atomic: optimize xchg and xchg64 on loong64
- cmd/compiler,runtime/internal/atomic: optimize xadd and xadd64 on loong64
- cmd/compiler,runtime/internal/atomic: optimize And{32,8} and Or{32,8} on loong64
- Revert "cmd/link: workaround linkshared test errors on loong64."
- syscall: implement Ptrace{Set,Get}Regs using PTRACE_{GET,SET}REGSET on all linux platforms
- cmd/internal/obj/loong64: remove the invalid plan9 format of the BREAK instruction

* Mon Oct 9 2023 Funda Wang <fundawang@yeah.net> - 1.20.9-1
- New version 1.20.9
- Use local sumdb rather than disable it

* Fri Jun 09 2023 Funda Wang <fundawang@yeah.net> - 1.20.5-1
- New version 1.20.5

* Wed May 03 2023 Funda Wang <fundawang@yeah.net> - 1.20.4-1
- New version 1.20.4

* Thu Apr 13 2023 DengXiewei <dengxiewei@linux.alibaba.com> - 1.20.3-2
- Remove the useless obsoletes
- Make the description clearer

* Thu Apr 06 2023 Funda Wang <fundawang@yeah.net> - 1.20.3-1
- New version 1.20.3
- Disable race package due go 1.20 new feature
- Drop abi generation, it produces unexpanded provides for this package

* Tue Jan 3 2023 Kun(llfl) <llfl@linux.alibaba.com> - 1.19.4-1
- update version to 1.19.4

* Tue Jun 14 2022 happy_orange <songnannan@linux.alibaba.com> - 1.18.3-1
- init from upstream
